﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq

Public Class ModelFacade

    Public Function createClaim(ByVal formData As ClaimFormDTO) As ClaimDTO
        ' get the policy number and look for a matching policy in the database
        Dim policyNumber As Integer = formData.policyNumber
        Dim policyDAO As PolicyDAO = New PolicyDAO()
        Dim policy As PolicyDTO = policyDAO.getPolicyByNumber(policyNumber)
        If IsNothing(policy) Then
            Return Nothing
        End If
        ' if we find a match, create a Claim and link it to the policy  
        Dim claim As ClaimDTO = New ClaimDTO()
        Dim generator As ReferenceGenerator = New ReferenceGenerator()
        If IsNothing(formData.amount) Then
            formData.amount = 0
        End If
        claim.amount = formData.amount
        If IsNothing(formData.description) Then
            formData.description = ""
        End If
        claim.description = formData.description
        claim.claimDate = DateTime.Now
        claim.isApproved = False
        Dim reference As String = generator.getReference(formData, policy)
        claim.reference = reference
        claim.policyID = policy.policyID
        ' write the claim to the database
        Dim claimDAO As ClaimDAO = New ClaimDAO()
        claimDAO.saveClaim(claim)
        ' set up the foreign key in the database
        claimDAO.linkToPolicy(claim, policy)
        ' link the two objects
        claim.policy = policy
        ' return the claim, associated with the policy
        Return claim
    End Function

    Public Function getClaims(ByVal whereClause As String) As List(Of ClaimDTO)
        Dim myDAO As ClaimDAO = getClaimDAO()
        Dim claimCollection As List(Of ClaimDTO) = myDAO.getClaimList(whereClause)
        Return claimCollection
    End Function

    Public Function getClaimByRef(ByVal reference As String) As ClaimDTO
        Dim myDAO As ClaimDAO = getClaimDAO()
        Return myDAO.getClaimByRef(reference)
    End Function

    Public Sub updateClaim(ByVal claim As ClaimDTO)
        Dim myDAO As ClaimDAO = getClaimDAO()
        myDAO.updateClaim(claim)
    End Sub

    Public Sub deleteClaim(ByVal claim As ClaimDTO)
        Dim myDAO As ClaimDAO = getClaimDAO()
        myDAO.deleteClaim(claim)
    End Sub

    Public Function getPolicy(ByVal policyNumber As Integer) As PolicyDTO
        Dim myDAO As PolicyDAO = getPolicyDAO()
        Dim myDTO As PolicyDTO = myDAO.getPolicyByNumber(policyNumber)
        Return myDTO
    End Function

    Private Function getClaimDAO() As ClaimDAO
        Dim myDAO As ClaimDAO = New ClaimDAO()
        Return myDAO
    End Function
    Private Function getPolicyDAO() As PolicyDAO
        Dim myDAO As PolicyDAO = New PolicyDAO()
        Return myDAO
    End Function

End Class
