﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlClient
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq


Public Class PolicyDAO
    Inherits DAO

    Public Function getPolicyList() As List(Of PolicyDTO)
        Return getPolicyList(Nothing)
    End Function

    ' fetch list of policies
    Public Function getPolicyList(ByVal whereClause As String) As List(Of PolicyDTO)
        If IsNothing(whereClause) Then
            whereClause = ""
        End If
        Dim foundPolicies As List(Of PolicyDTO) = New List(Of PolicyDTO)
        Dim myConn As SqlConnection = New SqlConnection(connectionString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM policy " + whereClause
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        While myDR.Read()
            foundPolicies.Add(makeDTO(myDR))
            ' create new DTO and add to list 
        End While
        Return foundPolicies
    End Function

    ' fetch a policy by ID or key
    Public Function getPolicyByKey(ByVal policyKey As Integer) As PolicyDTO
        Dim myConn As SqlConnection = New SqlConnection(connectionString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM policy WHERE (policyID=" _
            + policyKey.ToString() + ")"
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        If myDR.Read() = False Then
            Return Nothing
        End If
        Return makeDTO(myDR)
    End Function
    ' fetch a policy by policyNumber 
    Public Function getPolicyByNumber(ByVal policyNumber As Integer) As PolicyDTO
        Dim myConn As SqlConnection = New SqlConnection(connectionString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM policy WHERE (policyNumber=" _
            + policyNumber.ToString() + ")"
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        If myDR.Read() = False Then
            Return Nothing
        End If
        Return makeDTO(myDR)
    End Function

    ' helper method 
    Private Function makeDTO(ByVal myDR As SqlDataReader) As PolicyDTO
        Dim myPolicy As PolicyDTO = New PolicyDTO()
        myPolicy.policyID = myDR.GetInt32(0)
        myPolicy.policyNumber = myDR.GetInt32(1)
        myPolicy.policyType = myDR.GetString(2)
        myPolicy.startDate = myDR.GetDateTime(3)
        myPolicy.annualPremium = myDR.GetDecimal(4)
        myPolicy.isPaidUp = (myDR.GetString(5).StartsWith("Y"))
        myPolicy.policyHolderID = myDR.GetInt32(6)
        Return myPolicy
    End Function

    ' save a policy object to the database 
    Public Sub savePolicy(ByVal myPolicy As PolicyDTO)
        Dim myConn As SqlConnection = New SqlConnection(connectionString)
        myConn.Open()
        Dim myComm As SqlCommand = New SqlCommand("UPDATE policy SET reference = @reference, description = @description, amount = @amount, approved = @approved, claimDate = @claimDate, policyID = @policyID WHERE claimID = @claimID", _
            myConn)
        myComm.Parameters.AddWithValue("@policyID", myPolicy.policyID)
        myComm.Parameters.AddWithValue("@policyNumber", myPolicy.policyNumber)
        myComm.Parameters.AddWithValue("@policyType", myPolicy.policyType)
        myComm.Parameters.AddWithValue("@startDate", myPolicy.startDate)
        myComm.Parameters.AddWithValue("@annualPremium", myPolicy.annualPremium)
        If myPolicy.isPaidUp Then
            myComm.Parameters.AddWithValue("@isPaidUp", "Y")
        Else
            myComm.Parameters.AddWithValue("@isPaidUp", "N")
        End If
        myComm.Parameters.AddWithValue("@policyHolderID", myPolicy.policyID)
        Dim rows As Integer = myComm.ExecuteNonQuery()
        If rows <> 1 Then
            Throw New Exception("Unexpected Result for Update")
        End If
    End Sub
End Class
